#include "test.h"
#include "mylib.h"

#pragma comment(linker, "/section:Shared,rws")
#pragma data_seg("shared")
HWND ghWnd = NULL;
HINSTANCE ghInstance;
HHOOK hHook = NULL;
#pragma data_seg()

BOOL WINAPI DllMain (HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
switch (dwReason) {
	case DLL_PROCESS_ATTACH:
		NotUseParameters(1, lpReserved);
		ghInstance = hInstance;
		MessageBox(NULL, "Attach", "OK", MB_OK);
		break;

	case DLL_PROCESS_DETACH:
		MessageBox(NULL, "Detach", "OK", MB_OK);
		break;
	}
return TRUE;
}

LRESULT CALLBACK MyHookProc (int nCode, WPARAM wp, LPARAM lp)
{
if (nCode<0)
	goto ret;
else if (ghWnd==NULL)
	MessageBox(NULL, "EBhEnhȂ", "DLL", MB_OK);
else if (wp==VK_ESCAPE)
	PostMessage(ghWnd, WM_KEYHOOK, (WPARAM)0, (LPARAM)0);
ret:
	return CallNextHookEx(hHook, nCode, wp, lp);
}

EXPORT BOOL SetHook (void)
{
hHook = SetWindowsHookEx(WH_KEYBOARD, MyHookProc, ghInstance, 0);
if (hHook==NULL)
	return FALSE;
return TRUE;
}

EXPORT BOOL ResetHook (void)
{
if (!UnhookWindowsHookEx(hHook))
	return FALSE;
return TRUE;
}

EXPORT void SetWndHandle (HWND hWnd)
{
ghWnd = hWnd;
return;
}